package eu.mhsl.craftattack.spawn.util;

import eu.mhsl.craftattack.spawn.Main;
import org.bukkit.Bukkit;

import java.util.function.Consumer;

public class Countdown {
    private final int countdownFrom;
    private boolean running;
    private int taskId;
    private int current;
    private final Consumer<Integer> announcement;
    private final Runnable onDone;

    public Countdown(int countdownFrom, Consumer<Integer> announcement, Runnable onDone) {
        this.countdownFrom = countdownFrom;
        this.current = countdownFrom;
        this.announcement = announcement;
        this.onDone = onDone;
    }

    public void start() {
        if(this.running) throw new IllegalStateException("Countdown already running!");
        this.running = true;
        this.taskId = Bukkit.getScheduler().scheduleSyncRepeatingTask(Main.instance(), this::tick, 20, 20);
    }

    public void cancel() {
        if(!this.running) throw new IllegalStateException("Countdown not running!");
        this.running = false;
        Bukkit.getScheduler().cancelTask(this.taskId);
        this.taskId = 0;
        this.current = countdownFrom;
    }

    public boolean isDone() {
        return current <= 0;
    }

    private void tick() {
        if(current <= 60 && (current <= 10 || current % 10 == 0)) {
            this.announcement.accept(current);
        }
        this.current--;

        if(isDone()) {
            this.onDone.run();
            this.cancel();
        }
    }
}
